#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define mk make_pair


struct DNKChar {
    char ch;
    ll count;
};

ll nextChar(const string& str, ll i) {
    ll j;
    for (j = i; j < str.length(); j++) {
        if (!isdigit(str[j])) {
            return j;
        }
    }
    return j;
}

ll insertionShift(ll len) {
    if (1 <= len && len <= 2)
        return 1;
    if (3 <= len && len <= 11)
        return 2;
    if (12 <= len && len <= 101)
        return 10;
    if (102 <= len && len <= 1099)
        return 100;
    if (1100 <= len && len <= 10099)
        return 1000;
    return 0;
}

bool delete1Char(const list<DNKChar>& lst) {
    ll i = 0;
    for (auto ch : lst) {
        i += ch.count;
        if (ch.count == 1) {
            cout << 2 << ' ' << i + 1 << endl;
            return true;
        }
        
    }
    return false;
}

bool isDigitDeletable(ll num) {
    return num == 10 || num == 100 || num == 1000 || num == 10000 || num == 100000;
}

char getOther(string& chars) {
    if (chars.find('A') == string::npos)
        return 'A';
    if (chars.find('G') == string::npos)
        return 'G';
    if (chars.find('C') == string::npos)
        return 'C';
    return 'T';
}

bool delete1Digit(const list<DNKChar> lst) {
    ll i = 0;
    for (auto ch : lst) {
        if (isDigitDeletable(ch.count)) {
            cout << 2 << ' ' << i + 1 << endl;
            return true;
        }
        i += ch.count;
    }
    return false;
}

bool replaceDigitToChar(list<DNKChar> lst) {
    ll i = 0;
    list<DNKChar>::iterator prev, next;
    for (auto it = lst.begin(); it != lst.end(); it++) {
        if (it->count == 2) {
            prev = --it; next = ++(++it); --it;
            string str({it->ch, prev->ch, next->ch});
            cout << 3 << ' ' << i + 1 << " " << getOther(str) << endl;
            return true;
        }
        i += it->count;
    }
    return false;
}

void solve() {
    //ll codedLen; ll originalLen; cin >> codedLen >> originalLen;
    string str; cin >> str;

    list<DNKChar> chars;
    ll current, last = 0;
    while ((current = nextChar(str, last)) != str.length()) {
        ll num;
        try {
            num = stoi(str.substr(last, current - last));
        } catch (exception& e) {
            num = 1;
        }
        char ch = str[current];
        chars.push_back({ch, num});
        // cout << num << " " << ch << endl;
        last = current + 1;
    }



    // A B A    - delete (< -1)
    // 5 1 5
    // B        - delete: 2B -> B (-1)
    // 2
    ll i = 0;
    ll maxProfit = -1, profit, maxProfitIdx = -1;
    list<DNKChar>::iterator prev, next;
    for (auto it = chars.begin(); it != chars.end(); it++) {
        i += it->count;
        if (--it == chars.begin() || ++(++it) == chars.end()) {
            --it;
            continue;
        }
        if (it->count == 1) {
            prev = --it; next = ++(++it); --it;
            profit = prev->count + next->count;
            //cout << "Found " << prev->ch << " " << next->ch << endl;
            if (prev->ch == next->ch) {
                if (profit > maxProfit) {
                    maxProfit = profit;
                    maxProfitIdx = i + 1;
                }
            }
        }
    }

    if (maxProfit == -1) {
        // try delete 1 char
        if (!delete1Char(chars)) {
            // try delete 1 digit
            if (!delete1Digit(chars)) {
                if (!replaceDigitToChar(chars)) {
                    cout << 1 << ' ' << 1 << ' '
                         << (chars.front().ch == 'A') << endl;
                    return;
                }
            }
        }

    } else {
        cout << 2 << " " << maxProfitIdx << endl;
    }



    i = 0;
    ll maxLen = -1, maxLenIdx = -1;
    char maxLenChar = 0;
    for (auto& it : chars) {
        if (it.count > maxLen) {
            maxLen = it.count;
            maxLenIdx = i;
            maxLenChar = it.ch;
        }
        i += it.count;
    }

    // insert
    cout << 1 << ' ' << maxLenIdx + insertionShift(maxLen) << ' '
        << ((maxLenChar == 'A')? ('C') : ('A')) << endl;
}

int main() {
    int tests = 1; //cin >> tests;
    while (tests--) {
        solve();
    }

    return 0;
}
