#include <bits/stdc++.h>
using namespace std;
#define ll long long

bool ok(ll indexes[], ll n, string& a, string& b, string& c) {
    if (a[indexes[0]] == '0' ||
        b[indexes[0]] == '0' ||
        c[indexes[0]] == '0') {
        return false;
    }

    if ((a[indexes[0]] - '0') + (b[indexes[0]] - '0') > (c[indexes[0]] - '0')) {
        return false;
    }

    ll a_int = 0, b_int = 0, c_int = 0;
    for (ll i = n - 1, m = 1; i >= 0; i--, m *= 10) {
        a_int += (a[indexes[i]] - '0') * m;
        b_int += (b[indexes[i]] - '0') * m;
        c_int += (c[indexes[i]] - '0') * m;
    }

    //cout << a_int << ' ' << b_int << ' ' << c_int << endl;

    return (a_int + b_int) == c_int;
}


void solve(string& a, string& b, string& c) {
    ll n = a.length();
    const ll MOD = 10e9 + 7;
    ll indexes[n]; for (ll i = 0; i < n; i++) indexes[i] = i;
    ll cnt = 0;
    do {
        //for (int i = 0; i < n; i++) cout << indexes[i] << ' '; cout << endl;
        if (ok(indexes, n, a, b, c)) {
            cnt += 1;
        }
    } while (next_permutation(indexes, indexes + n));

    cout << cnt % MOD << endl;
}

string intToString(int n) {
    string s;
    while (n > 0) {
        s += '0' + n % 10;
        n /= 10;
    }
    reverse(s.begin(), s.end());
    return s;
}

int main() {
    string a, b, c; cin >> a >> b >> c;
    solve(a, b, c);
    //string s1, s2, s3;
//    for (int a = 100; a <= 999; a++) {
//        for (int b = 100; b <= 999; b++) {
//            for (int c = 100; c <= 999; c++) {
//                s1 = intToString(a);
//                s2 = intToString(b);
//                s3 = intToString(c);
//                cout << s1 + ' ' + s2 + ' ' + s3 << endl;
//                solve(s1, s2, s3);
//            }
//        }
//    }
    return 0;
}


