#include <bits/stdc++.h>
using namespace std;
#define ll long long

bool isCorrectMatrix(ll L, ll C, ll** m) {
    for (ll l = 0; l < L; l++) {
        for (ll c = 0; c < C; c++) {
            for (ll w = 1; w < C - c; w++) {
                for (ll h = 1; h < L - l; h++) {
                    if (m[l][c] == m[l + h][c] &&
                        m[l][c] == m[l][c + w] &&
                        m[l][c] == m[l + h][c + w]) {
                        return false;
                    }
                }
            }
        }
    }
    return true;
}

void solve3(ll lines, ll columns) {
    ll** matrix = new ll*[lines];
    for (ll l = 0; l < lines; l++)
        matrix[l] = new ll[columns];

    int n = 0;
    if (lines * columns > 10) {
        //             0  1  2  3  4  5  6  7  8  9  10 11 12 13 14
        int start[] = {2, 1, 2, 1, 0, 1, 2, 0, 1, 2, 0, 2, 1, 0, 2, 1, 2};
        for (n = 0; n < lines * columns && n < 12; n++) {
            matrix[n / columns][n % columns] = start[n];
        }
    }

    ll maxN = lines * columns - n;
    ll maxCombination = pow(3, maxN + 1) - 1;
    //maxCombination /= 4;
    for (ll combination = 0; combination <= maxCombination; combination++) {
        // build matrix
        ll comb = combination;
        for (ll _n = 0; n < maxN + n; n++) {
            matrix[_n / columns][_n % columns] = comb % 3;
            comb /= 3;
        }
        if (isCorrectMatrix(lines, columns, matrix)) {
            for (ll l = 0; l < lines; l++) {
                for (ll c = 0; c < columns; c++) {
                    cout << matrix[l][c] + 1 << ' ';
                }
                cout << '\n';
            }
            return;
            cout << '\n';
        }
    }
}

void solve2(ll lines, ll columns) {
    ll** matrix = new ll*[lines];
    for (ll l = 0; l < lines; l++)
        matrix[l] = new ll[columns];

    int n = 0;
    //             0  1  2  3  4  5  6  7  8
    int start[] = {1, 0, 1, 0, 1, 0, 1, 0, 1};
    for (; n < lines * columns && n < 6; n++) {
        matrix[n / columns][n % columns] = start[n];
    }

    ll maxN = lines * columns - n;
    ll maxCombination = pow(2, maxN + 1) - 1;
    //maxCombination /= 4;
    for (ll combination = 0; combination <= maxCombination; combination++) {
        // build matrix
        ll comb = combination;
        for (ll _n = n; _n < maxN + n; _n++) {
            matrix[_n / columns][_n % columns] = comb % 2;
            comb /= 2;
        }
        if (isCorrectMatrix(lines, columns, matrix)) {
            for (ll l = 0; l < lines; l++) {
                for (ll c = 0; c < columns; c++) {
                    cout << matrix[l][c] + 1 << ' ';
                }
                cout << '\n';
            }
            return;
            cout << '\n';
        }
    }
}


void solve() {
    ll Lines, Columns, Colors; cin >> Lines >> Columns >> Colors;


    if (Colors == 2) {
        solve2(Lines, Columns);
    } else { // Colors == 3
        solve3(Lines, Columns);
    }
}

int main() {
    solve();
    return 0;
}