#include <bits/stdc++.h>
using namespace std;
#define ll long long

bool ok(ll indexes[], ll n, string& a, string& b, string& c) {
    if (a[indexes[0]] == '0' ||
        b[indexes[0]] == '0' ||
        c[indexes[0]] == '0') {
        return false;
    }

    if ((a[indexes[0]] - '0') + (b[indexes[0]] - '0') > (c[indexes[0]] - '0')) {
        return false;
    }

    ll a_int = 0, b_int = 0, c_int = 0;
    for (ll i = 0, m = 1; i < n; i++, m *= 10) {
        a_int += (a[indexes[i]] - '0') * m;
        b_int += (b[indexes[i]] - '0') * m;
        c_int += (c[indexes[i]] - '0') * m;
    }

    //cout << a_int << ' ' << b_int << ' ' << c_int << endl;

    return (a_int + b_int) == c_int;
}


void solve() {
    string a, b, c; cin >> a >> b >> c;
    ll n = a.length();
    const ll MOD = 10e9 + 7;
    ll indexes[n]; for (ll i = 0; i < n; i++) indexes[i] = i;
    ll cnt = 0;
    do {
        //for (int i = 0; i < n; i++) cout << indexes[i] << ' '; cout << endl;
        if (ok(indexes, n, a, b, c)) {
            cnt += 1;
        }
    } while (next_permutation(indexes, indexes + n));

    cout << cnt % MOD;
}

int main() {
    solve();
    return 0;
}


